import React, { useState, useEffect } from 'react'
import './index.scss'
import '../../../../../assets/css/iconfont.css'
import { Image, Slider, Textarea } from '@tarojs/components'
import SubmitBuyHouseResult from '../SubmitBuyHouseResult/index'
import questions from './formData'

export default function BuyHouse (props) {
  const { change = () => { }, toSubmit = () => {} } = props

  const [FormData, setFormData] = useState(questions)

  const [StepId, setStepId] = useState(1)
  const [StepRange, setStepRange] = useState([0, 4])

  const [ShowPopup, setShowPopup] = useState(false)

  useEffect(() => {
    if(StepId === 1) {
      setStepRange([0, 4])
    } else if(StepId === 2) {
      setStepRange([4, 7])
    } else if(StepId === 3) {
      setStepRange([7, 10])
    } else if(StepId === 4) {
      setStepRange([10, 12])
    }
    change(StepId)
  }, [StepId])

  const CutCheckbox = (item, index) => {
    return () => {
      let newFormData = [...FormData]
      newFormData[index].resultId = item.id
      newFormData[index].result = item.name
      setFormData([...newFormData])
    }
  }

  const Rangehange = (e, index) => {
    let newFormData = [...FormData]
    newFormData[index].result = e.detail.value
    setFormData([...newFormData])
  }

  const remarkInput = (e, index) => {
    let newFormData = [...FormData]
    newFormData[index].remark = e.detail.value
    setFormData([...newFormData])
  }

  const textareaInput = (e, index) => {
    let newFormData = [...FormData]
    newFormData[index].result = e.detail.value
    setFormData([...newFormData])
  }

  const NextStep = () => {
    if (StepId < 4) {
      setStepId(StepId + 1)
    } else {
      toSubmit(FormData)
    }
  }

  const PrevStep = () => {
    if (StepId > 1) {
      setStepId(StepId - 1)
    }
  }

  return (
    <view className='components BuyHouse'>
      {
        ShowPopup &&
        <SubmitBuyHouseResult></SubmitBuyHouseResult>
      }
      {
        FormData.map((item, index) => (
          <view className='Step' key={`Form-${index}`}>
            {
              index >= StepRange[0] && index < StepRange[1] &&
              <view>
                <text>{item.question}</text>
                {
                  item.type === 'checkbox' &&
                  <view className='CheckList'>
                    {
                      item.options.map((subItem, subIndex) => (
                        <view key={`${item.key}-${subIndex}`} className={item.resultId === subItem.id ? 'active' : ''} onClick={CutCheckbox(subItem, index)}>
                          {subItem.name}
                          <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                        </view>
                      ))
                    }
                  </view>
                }
                {
                  item.type === 'checkbox' && item.remark !== undefined &&
                  <view className='Textarea'>
                    <Textarea placeholder="请说出您的其他需求，让我们更好的为您服务！" onInput={(e) => {remarkInput(e, index)}} />
                  </view>
                }
                {
                  item.type === 'range' &&
                  <view className='RangeList'>
                    <Slider activeColor="#193C83" block-color="#193C83" onChange={(e) => { Rangehange(e, index) }} min={item.options[0]} max={item.options[1]} show-value />
                  </view>
                }
                {
                  item.type === 'select' &&
                  <view className='Area'>
                    <view className='flex-h'>
                      {
                        item.key === 'district' &&
                        <text className='iconfont icon-dingwei'></text>
                      }
                      <text>不限</text>
                      <view className='flex-item'></view>
                      <text className='iconfont icon-jiantoudown'></text>
                    </view>
                  </view>
                }
                {
                  item.type === 'textarea' &&
                  <view className='Textarea'>
                    <Textarea placeholder="请说出您的其他需求，让我们更好的为您服务！" onInput={(e) => {textareaInput(e, index)}} />
                  </view>
                }
              </view>
            }
          </view>
        ))
      }
      {/* {
        StepId === 1 &&
        <view className='Step'>
          <view>
            <text>意向区域</text>
            <view className='Area'>
              <view className='flex-h'>
                <text className='iconfont icon-dingwei'></text>
                <text>不限</text>
                <view className='flex-item'></view>
                <text className='iconfont icon-jiantoudown'></text>
              </view>
            </view>
          </view>

          <view>
            <text>意向楼盘</text>
            <view className='Purpose'>
              <view>
                <Input placeholder="请输入意向楼盘" />
              </view>
            </view>
          </view>

          <view>
            <text>您想购买的是首套房还是二套房？</text>
            <view className='CheckList'>
              {
                SingleList.map((item, index) => (
                  <view key={`SingleItem-${index}`} className={CurrnetSingleId === item.id ? 'active' : ''} onClick={CutSingleId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>

          <view>
            <text>总价预算范围</text>
            <view className='PriceRange'>
              <view className='flex-h'>
                <view className='flex-item'>
                  <Input placeholder="最小面积㎡" />
                </view>
                <text>-</text>
                <view className='flex-item'>
                  <Input placeholder="最大面积㎡" />
                </view>
              </view>
            </view>
          </view>
        </view>
      }

      {
        StepId === 2 &&
        <view className='Step'>
          <view>
            <text>您想购买的是二手房还是新房？</text>
            <view className='CheckList'>
              {
                NewOldList.map((item, index) => (
                  <view key={`NewOldItem-${index}`} className={CurrnetNewOldId === item.id ? 'active' : ''} onClick={CutNewOldId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
          <view>
            <text>居室要求</text>
            <view className='CheckList'>
              {
                HouseTypeList.map((item, index) => (
                  <view key={`HouseTypeItem-${index}`} className={CurrnetHouseTypeId === item.id ? 'active' : ''} onClick={CutHouseTypeId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
          <view>
            <text>面积要求</text>
            <view className='CheckList'>
              {
                AreaList.map((item, index) => (
                  <view key={`AreaItem-${index}`} className={CurrnetAreaId === item.id ? 'active' : ''} onClick={CutAreaId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
        </view>
      }

      {
        StepId === 3 &&
        <view className='Step'>
          <view>
            <text>价格要求</text>
            <view className='RangeList'>
              <Slider activeColor="#193C83" block-color="#193C83" change={PriceRangehange} min="50" max="200" show-value />
            </view>
          </view>
          <view>
            <text>偏好设置</text>
            <view className='CheckList'>
              {
                PreferenceList.map((item, index) => (
                  <view key={`PreferenceItem-${index}`} className={CurrnetPreferenceId === item.id ? 'active' : ''} onClick={CutPreferenceId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
          <view>
            <text>购房目的</text>
            <view className='CheckList'>
              {
                GoalList.map((item, index) => (
                  <view key={`GoalItem-${index}`} className={CurrnetGoalId === item.id ? 'active' : ''} onClick={CutGoalId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
        </view>
      }

      {
        StepId === 4 &&
        <view className='Step'>
          <view>
            <text>计划在多久购房？</text>
            <view className='CheckList'>
              {
                LongTimeList.map((item, index) => (
                  <view key={`LongTimeItem-${index}`} className={CurrnetLongTimeId === item.id ? 'active' : ''} onClick={CutLongTimeId(item.id)}>
                    {item.name}
                    <Image mode='heightFix' src={require('../../../../../assets/findHouse-icon1.png')}></Image>
                  </view>
                ))
              }
            </view>
          </view>
          <view>
            <text>您还有哪些需要备注的信息？</text>
            <view className='Textarea'>
              <Textarea placeholder="请说出您的其他需求，让我们更好的为您服务！" />
            </view>
          </view>
        </view>
      } */}

      <view className='Btn'>
        <text className='active' onClick={NextStep}>下一步</text>
        <text onClick={PrevStep}>返回</text>
      </view>
    </view>
  )
}
